<?xml version="1.0"?>
<!-- This transformation removes plugin build directives for platform-specific
 plugins aimed at other platforms than Linux and GTK+.
 It also fixes values of properties "os" and "ws" to "linux" and "gtk" respectively.
-->
<xsl:transform version="1.0"
               xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" encoding="UTF-8"/>

<xsl:template match="ant[   contains(@dir, 'win32')
                         or contains(@dir, 'macosx')
                         or contains(@dir, 'qnx')
                         or contains(@dir, 'hpux')
                         or contains(@dir, 'carbon')
                         or contains(@dir, 'photon')
                         or contains(@dir, 'motif')]"/>

<xsl:template match="ant/property[@name='os']">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="value">linux</xsl:attribute>
  </xsl:copy>
</xsl:template>

<xsl:template match="ant/property[@name='ws']">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="value">gtk</xsl:attribute>
  </xsl:copy>
</xsl:template>

<xsl:template match="antcall/param[(@name='os' or @name='ws' or @name='arch')
                                   and @value='*']"/>

<xsl:template match="node()">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="@*">
  <xsl:copy/>
</xsl:template>

</xsl:transform>
