<?xml version="1.0"?>
<!-- This transformation sets version attribute in the plugin element
 to the version parameter that needs to be specified.
-->
<xsl:transform version="1.0"
               xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:output method="xml" encoding="UTF-8"/>

<xsl:param name="version"/>

<xsl:template match="/plugin">
  <xsl:copy>
    <xsl:apply-templates select="@*"/>
    <xsl:attribute name="version">
      <xsl:value-of select="$version"/>
    </xsl:attribute>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<xsl:template match="node()">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>

<xsl:template match="@*">
  <xsl:copy/>
</xsl:template>

</xsl:transform>
