%define swt_binver 3063

Name: eclipse
Version: 3.0.1
Release: alt1

%def_without origsrc
%def_disable debug

Summary: An extensible software development platform
Summary(ru_RU.KOI8-R):    
Group: Development/Other
License: CPL
URL: http://www.eclipse.org/

%define req_ant_ver 1.6.2
%define req_jsch_ver 0.1.16
%define req_junit_ver 3.8.1
%define req_lucene_ver 1.3.1
%define fake_lucene_ver 1.3
%define req_servletapi_ver 2.3
%define req_tomcat_ver 4.1.30

Requires: j2se >= 1.4
Requires: java-common
Requires: swt = %version
Requires: swt-mozilla = %version
Requires: ant >= %req_ant_ver
Requires: ant-optional
Requires: jsch >= %req_jsch_ver
Requires: lucene >= %req_lucene_ver
Requires: tomcat4 >= %req_tomcat_ver
Requires: servletapi >= %req_servletapi_ver
Requires: jakarta-commons-beanutils
Requires: jakarta-commons-collections
Requires: jakarta-commons-digester
Requires: jakarta-commons-logging
Requires: jakarta-commons-modeler
Requires: jakarta-regexp
Requires: mx4j

%define eclipse_home %_libdir/%name

%define eclipse_features platform jdt pde platform.source jdt.source pde.source

%ifarch %ix86
%define earch x86
%else
%define earch %_arch
%endif

#define buildflags -os %_target_os -ws gtk -arch %earch
%if_enabled debug
%define javac_debug %nil
%else
%define javac_debug -DjavacDebugInfo=off
%endif
%define javac_opts -DjavacVerbose=false -DjavacFailOnError=true %javac_debug

%define ant_version %(rpmquery -q --qf='%{VERSION}' ant)
%define junit_version %(rpmquery -q --qf='%{VERSION}' junit)
%define lucene_version %(rpmquery -q --qf='%{VERSION}' lucene)
%define tomcat_version %(rpmquery -q --qf='%{VERSION}' tomcat4)

%define ant_flags -DinstallOs=%_target_os -DinstallWs=gtk -DinstallArch=%earch -DantVersion=%ant_version -DjunitVersion=%junit_version -DluceneVersion=%lucene_version -DtomcatVersion=%tomcat_version %javac_opts

%if_with origsrc
Source0: %name-sourceBuild-srcIncluded-%version.zip
%else
Source0: %name-%version.tar.bz2
%endif
Source1: %name.sh.in
Source2: %name.conf
Source3: %name-build-omit-foreign-platforms.xsl
Source4: %name-set-plugin-version.xsl
Source5: %name-build-feature-zips.xml

Patch0: %name-3.0.1-alt-externalize.patch
Patch1: %name-3.0.1-alt-build-native.patch

BuildPreReq: rpm-build-java

BuildRequires: glib2-devel
BuildRequires: libatk-devel libgtk+2-devel libpango-devel xorg-x11-libs

BuildRequires: ant >= %req_ant_ver
BuildRequires: j2se-devel >= 1.4
BuildRequires: swt = %version
BuildRequires: swt-mozilla = %version
BuildRequires: jsch >= %req_jsch_ver
BuildRequires: junit >= %req_junit_ver
BuildRequires: lucene >= %req_lucene_ver
BuildRequires: tomcat4 >= %req_tomcat_ver
BuildRequires: servletapi >= %req_servletapi_ver
BuildRequires: xsltproc
BuildRequires: pkgconfig
BuildRequires: netpbm
BuildRequires: unzip sed

%description
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

%package jdt
Summary: Eclipse Java Development Tools
Group: Development/Java
Requires: %name = %version-%release
Requires: junit >= %req_junit_ver

%package pde
Summary: Eclipse Plug-in Development Environment
Group: Development/Java
Requires: %name = %version-%release
Requires: %name-jdt = %version-%release

%package platform-source
Summary: Eclipse Platform source feature
Group: Development/Java
Requires: %name = %version-%release

%package jdt-source
Summary: Eclipse JDT source feature
Group: Development/Java
Requires: %name = %version-%release

%package pde-source
Summary: Eclipse PDE source feature
Group: Development/Java
Requires: %name = %version-%release

%description jdt
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

The JDT provides the tool plug-ins for the platform that implement a
Java IDE for power-users, that supports the development of any Java
application, including Eclipse plug-ins. The JDT adds the notion of
Java projects and a Java perspective to the Eclipse platform, as well
as a number of views, editors, wizards, builders, and code merging and
refactoring tools. The JDT allows Eclipse to be a development
environment for itself. The JDT plug-ins themselves can also be
further extended by other tool builders.

%description pde
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

The PDE project provides a number of views and editors that make is
easier to build plug-ins for Eclipse. Using the PDE, you can create
your plug-in manifest file (plugin.xml), specify your plug-in runtime
and other required plug-ins, define extension points, including their
specific markup, associate XML Schema files with the extension point
markup so extensions can be validated, create extensions on other
plug-in extension points, etc. The PDE makes integrating plug-ins easy
and fun.

%description platform-source
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

This add-on provides resources for Eclipse Platform developers.

%description jdt-source
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

This add-on provides resources for Eclipse JDT developers.

%description pde-source
Eclipse is an open source software development project dedicated to
providing a robust, full-featured, commercial-quality, industry
platform for the development of highly integrated tools.

This add-on provides resources for Eclipse PDE developers.

%prep

%if_with origsrc

%setup -q -n %name-%version -c
%patch0 -p1
%patch1 -p0
%__rm -rf plugins/*aix*
%__rm -rf plugins/*hpux*
%__rm -rf plugins/*macosx*
%__rm -rf plugins/*qnx*
%__rm -rf plugins/*solaris*
%__rm -rf plugins/*win32*
%__rm -rf plugins/*carbon*
%__rm -rf plugins/*motif*
%__rm -rf plugins/*photon*
%__rm -f build.bat
%__rm -f plugins/org.apache.ant/bin/*.bat
%__rm -f plugins/platform-launcher/bin/%_target_os/gtk*/eclipse
for platform in aix hpux macosx qnx solaris win32 carbon motif photon; do
    find plugins -type d -name $platform -print0 | xargs -r0 %__rm -rf --
done
find plugins -name '*.jar' ! -name 'swttools.jar' -print0 |
    xargs -r0 %__rm -f --
find plugins -name '*.zip' ! -name 'osgiJavaDoc.zip' -print0 |
    xargs -r0 %__rm -f --
find plugins -name '*.so' -print0 | xargs -r0 %__rm -fv --
for f in features/*/build.xml; do
    xsltproc --output $f %SOURCE3 $f
done

%__mv 'plugins/org.eclipse.pde.build/notes/m2 notes.html' \
    plugins/org.eclipse.pde.build/notes/m2-notes.html

%else	# without origsrc

%setup -q

%endif	# with origsrc

%build

%__mkdir_p plugins/org.eclipse.swt.gtk/ws/gtk/
%__mkdir_p plugins/org.eclipse.swt.gtk64/ws/gtk/
for a in swt{,-pi,-mozilla}; do
    %__ln_s -f %_javadir/swt/$a.jar plugins/org.eclipse.swt.gtk/ws/gtk/$a.jar
    %__ln_s -f %_javadir/swt/$a.jar plugins/org.eclipse.swt.gtk64/ws/gtk/$a.jar
done

%__ln_s -f %_javadir/servletapi.jar plugins/org.eclipse.tomcat/servlet.jar
for a in catalina bootstrap \
         jasper-{compiler,runtime} \
         naming-{common,factory,resources} \
         servlets-{common,default,invoker,manager} \
         tomcat-{coyote,http11,util}
do
    %__ln_s -f %_javadir/tomcat4/$a.jar plugins/org.eclipse.tomcat/$a.jar
done

for a in ant ant-launcher ant-nodeps; do
    %__ln_s -f %_javadir/ant/$a.jar plugins/org.apache.ant/lib/$a.jar
done
%__ln_s -f %_javadir/ant/ant.jar \
    plugins/org.eclipse.core.resources/lib/ant.jar
%__ln_s -f ../../org.eclipse.ant.core/antsupport.jar \
    plugins/org.eclipse.core.resources/lib/antsupport.jar

%__ln_s -f %_javadir/jsch.jar \
    plugins/org.eclipse.team.cvs.ssh2/jsch-%req_jsch_ver.jar

%__ln_s -f %_javadir/junit.jar \
    plugins/org.junit/junit.jar

%__ln_s -f %_javadir/lucene.jar \
    plugins/org.apache.lucene/lucene-%fake_lucene_ver-final.jar

xsltproc --output plugins/org.apache.ant/plugin.xml \
         --stringparam version %ant_version \
    %SOURCE4 plugins/org.apache.ant/plugin.xml
xsltproc --output plugins/org.apache.lucene/plugin.xml \
         --stringparam version %lucene_version \
    %SOURCE4 plugins/org.apache.lucene/plugin.xml
xsltproc --output plugins/org.eclipse.tomcat/plugin.xml \
         --stringparam version %tomcat_version \
    %SOURCE4 plugins/org.eclipse.tomcat/plugin.xml
xsltproc --output plugins/org.junit/plugin.xml \
         --stringparam version %junit_version \
    %SOURCE4 plugins/org.junit/plugin.xml

# Give the compilation process more memory
export ANT_OPTS=-Xmx128M

%ant_build %ant_flags compile
#./build %buildflags -target compile

# Build the native stuff

cd plugins/org.eclipse.core.resources.linux/src
%make CFLAGS="$RPM_OPT_FLAGS" JAVA_HOME=%_libdir/j2se
%__mv libcore*.so ../os/%_target_os/%earch
cd -

cd plugins/org.eclipse.update.core.linux/src
%ant_build -Dcompile-flags="$RPM_OPT_FLAGS"
cd -

cd plugins/platform-launcher/library/gtk
%make -f make_gtk.mak \
    PROGRAM_OUTPUT=eclipse \
    PROGRAM_NAME=Eclipse \
    DEFAULT_OS=%_target_os \
    DEFAULT_OS_ARCH=%earch \
    DEFAULT_WS=gtk \
    OPTFLAGS="$RPM_OPT_FLAGS"
%__mv -f eclipse ../../bin/%_target_os/gtk/eclipse
cd -

# Bundle installed files
%__cp -f %SOURCE5 build-feature-zips.xml
%ant_build %ant_flags -f build-feature-zips.xml
#ant_build %ant_flags install
#./build %buildflags -target install

# Convert icons to PNG
for d in 16 32 48; do
    bmptopnm plugins/platform-launcher/library/icon${d}_full.bmp |
    pnmtopng >plugins/platform-launcher/library/icon${d}_full.png
done

%install

%__install -d -m755 %buildroot%eclipse_home

# Unzip binary distrubutions
for feature in %eclipse_features; do
    cd features/org.eclipse.${feature}
    unzip -Z -1 org.eclipse.${feature}_%version.bin.dist.zip \
          'plugins/?*' 'features/?*' |
	sed -e 's#^\(.*\)$#%eclipse_home/\1#' \
	    -e 's#^\(.*\)/$#%%dir \1#' \
	> ../../$feature.list
    unzip -q -o -d %buildroot%eclipse_home \
	org.eclipse.${feature}_%version.bin.dist.zip
    cd -
done
unzip -Z -1 features/org.eclipse.platform/org.eclipse.platform_%version.bin.dist.zip \
      '%_target_os.gtk.%earch/eclipse/?*' |
    sed -e 's#^%{_target_os}\.gtk\.%{earch}/eclipse#%{eclipse_home}#' \
        -e 's#^\(.*\)/$#%%dir \1#' \
    >> platform.list
%__mv %buildroot%eclipse_home/%_target_os.gtk.%earch/eclipse/{,.??}* \
      %buildroot%eclipse_home
rmdir %buildroot%eclipse_home/%_target_os.gtk.%earch/eclipse
%__chmod 755 %buildroot%eclipse_home/eclipse

# Symlinks to jars and libraries
%__install -d -m755 %buildroot%eclipse_home/plugins/org.eclipse.swt.gtk_%version/ws/gtk
for a in swt{,-pi,-mozilla}; do
    %__ln_s %_javadir/swt/$a.jar \
	%buildroot%eclipse_home/plugins/org.eclipse.swt.gtk_%version/ws/gtk/$a.jar
done
%__install -d -m755 %buildroot%eclipse_home/plugins/org.eclipse.swt.gtk_%version/os/%_target_os/%earch
for comp in {,-pi,-atk,-awt,-gnome,-mozilla}-gtk; do
    %__ln_s %_libdir/swt/libswt$comp-%swt_binver.so \
	%buildroot%eclipse_home/plugins/org.eclipse.swt.gtk_%version/os/%_target_os/%earch/libswt$comp-%swt_binver.so
done
for a in catalina bootstrap \
         jasper-{compiler,runtime} \
         naming-{common,factory,resources} \
         servlets-{common,default,invoker,manager} \
         tomcat-{coyote,http11,util}
do
    %__ln_s %_javadir/tomcat4/$a.jar \
	%buildroot%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/$a.jar
done
for a in commons-{beanutils,collections,digester,logging,logging-api,modeler}
do
    %__ln_s %_javadir/jakarta-$a.jar \
	%buildroot%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/$a.jar
done
for a in jakarta-regexp mx4j servletapi; do
    %__ln_s %_javadir/$a.jar \
	%buildroot%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/$a.jar
done
%__install -d -m755 %buildroot%eclipse_home/plugins/org.apache.ant_%ant_version/lib
for a in ant \
         ant-{antlr,jai,javamail,jdepend,jmf,jsch,junit,launcher,nodeps,stylebook,swing,trax} \
         ant-apache-{bcel,log4j,oro,regexp,resolver} \
         ant-commons-{logging,net}
do
    %__ln_s %_javadir/ant/$a.jar \
	%buildroot%eclipse_home/plugins/org.apache.ant_%ant_version/lib/$a.jar
done
%__ln_s %_javadir/lucene.jar \
    %buildroot%eclipse_home/plugins/org.apache.lucene_%lucene_version/lucene.jar
%__ln_s %_javadir/jsch.jar \
    %buildroot%eclipse_home/plugins/org.eclipse.team.cvs.ssh2_*/
%__ln_s %_javadir/junit.jar \
    %buildroot%eclipse_home/plugins/org.junit_%junit_version/junit.jar

# Launcher
%__mkdir_p %buildroot%_bindir
%__sed 's/@VERSION@/%version/g' %SOURCE1 >%buildroot%_bindir/%name
%__chmod 755 %buildroot%_bindir/%name
%__mkdir_p %buildroot%_sysconfdir
%__install -p -m644 %SOURCE2 %buildroot%_sysconfdir/eclipse.conf

# Icons, menu
%__mkdir_p %buildroot{%_iconsdir,%_liconsdir,%_miconsdir}
%__install -m644 plugins/platform-launcher/library/icon32_full.png \
    %buildroot%_iconsdir/%name.png
%__install -m644 plugins/platform-launcher/library/icon48_full.png \
    %buildroot%_liconsdir/%name.png
%__install -m644 plugins/platform-launcher/library/icon16_full.png \
    %buildroot%_miconsdir/%name.png
mkdir -p %buildroot%_menudir
cat << EOF > %buildroot%_menudir/%name
?package(%name): command="%_bindir/eclipse" icon="%name.png" \
longtitle="Extensible software development environment" \
needs="x11" title="Eclipse" \
section="Applications/Development/Development environments"
EOF

%post
/bin/touch -c %eclipse_home/plugins
%update_menus

%postun
/bin/touch -c %eclipse_home/plugins
%clean_menus

%post jdt
/bin/touch -c %eclipse_home/plugins

%postun jdt
/bin/touch -c %eclipse_home/plugins

%post pde
/bin/touch -c %eclipse_home/plugins

%postun pde
/bin/touch -c %eclipse_home/plugins

%post platform-source
/bin/touch -c %eclipse_home/plugins

%postun platform-source
/bin/touch -c %eclipse_home/plugins

%post jdt-source
/bin/touch -c %eclipse_home/plugins

%postun jdt-source
/bin/touch -c %eclipse_home/plugins

%post pde-source
/bin/touch -c %eclipse_home/plugins

%postun pde-source
/bin/touch -c %eclipse_home/plugins

%files -f platform.list
%dir %eclipse_home
%dir %eclipse_home/features
%dir %eclipse_home/plugins
%eclipse_home/plugins/org.eclipse.swt.gtk_%version/os
%eclipse_home/plugins/org.eclipse.swt.gtk_%version/ws
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/catalina.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/bootstrap.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/jasper-*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/naming-*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/servlet*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/tomcat-*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/commons-*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/jakarta-*.jar
%eclipse_home/plugins/org.eclipse.tomcat_%tomcat_version/mx4j.jar
%eclipse_home/plugins/org.apache.ant_%ant_version/lib/*.jar
%eclipse_home/plugins/org.apache.lucene_%lucene_version/lucene.jar
%eclipse_home/plugins/org.eclipse.team.cvs.ssh2_*/jsch.jar
%eclipse_home/plugins/org.junit_%junit_version/junit.jar
%_bindir/%name
%config(noreplace) %_sysconfdir/eclipse.conf
%_iconsdir/*.png
%_liconsdir/*.png
%_miconsdir/*.png
%_menudir/*

%files jdt -f jdt.list

%files pde -f pde.list

%files platform-source -f platform.source.list

%files jdt-source -f jdt.source.list

%files pde-source -f pde.source.list

%changelog
* Sun Jan 09 2005 Mikhail Zabaluev <mhz@altlinux.ru> 3.0.1-alt1
- Updated to 3.0.1
- Externalized SWT and third-party JARs
- Restructured packages to meet changed feature layout

* Fri Apr 04 2003 Mikhail Zabaluev <mhz@altlinux.ru> 2.1-alt1
- Initial release
- Major above-platform features ripped out to be subpackages
- The native module depending on GNOME is a subpackage too
